﻿procedure PRT(f: integer -> ()); // p04010 параметр - процедура
begin
  for var i := 1 to 10 do
    f(i);
  Println
end;

begin
  // предварительное описание процедурной переменной
  var t1: integer -> ();
  t1 := i -> begin Print(2 * i - 1) end;
  PRT(t1);
  // описание с инициализацией
  var t2: integer -> () := i -> begin Print(2 * i - 1) end;
  PRT(t2);
  // непосредственная передача лямбда-процедуры в процедуру
  PRT(i -> Print(2 * i - 1));
end.