﻿// p07006
type
  tПериод = (Полугодие1, Полугодие2, Год);
  tПредмет = (Информатика, Математика, Физика);
  tУченик = record
    ФИО: string;
    Оценка: array[tПредмет] of array[tПериод] of integer;
  end;

procedure Ввод(var Ученик: tУченик);
begin
  Ученик.ФИО := ReadlnString('Фамилия, И.О. ученика:');
  Write('Введите 9 оценок через пробел: ');
  for var Предмет := Информатика to Физика do
    for var Период := Полугодие1 to Год do
      Read(Ученик.Оценка[Предмет][Период]);
  Readln; // очистить буфер перед последующим вводом строки
end;

function СреднийБаллДетально(const Класс: array of tУченик): array of real;
begin
  var n := Класс.Length;
  Result := ArrFill(9,0.0); // создание с обнулением
  for var Ученик := 0 to Класс.High do
    for var Предмет := Информатика to Физика do
      for var Период := Полугодие1 to Год do
        Result[3 * Ord(Предмет) + Ord(Период)] +=
            Класс[Ученик].Оценка[Предмет][Период];
  for var i := 0 to Result.High do
    Result[i] /= n;
end;

procedure ВыводСреднегоБаллаДетально(Баллы: array of real);
begin
  Println('Средние баллы');
  for var Предмет := Информатика to Физика do
    for var Период := Полугодие1 to Год do
      $'{Предмет} за {Период}: {Баллы[3 * Ord(Предмет) + Ord(Период)]}'.Println
end;

function СреднийБалл(const Класс: array of tУченик): real;
begin
  var n := Класс.Length;
  Result := 0;
  for var Ученик := 0 to Класс.High do
    for var Предмет := Информатика to Физика do
      for var Период := Полугодие1 to Год do
        Result += Класс[Ученик].Оценка[Предмет][Период];
  Result /= n * 9
end;

begin
  var n := ReadlnInteger('Число учеников:');
  var НашКласс := new tУченик[n];
  for var Ученик := 0 to n - 1 do
    Ввод(НашКласс[Ученик]);
  ВыводСреднегоБаллаДетально(СреднийБаллДетально(НашКласс));
  $'Средний балл по классу за год {СреднийБалл(НашКласс):f2}'.Println;  
end.