﻿// p07007
type
  tУченик = record
    ФИО: string;
    Оценка: array of integer;
  end;

procedure Ввод(var Ученик: tУченик);
begin
  Ученик.ФИО := ReadlnString('Фамилия, И.О. ученика:');
  Ученик.Оценка := ReadArrInteger('Введите 9 оценок через пробел:', 9);
  Readln
end;

function СреднийБаллДетально(const Класс: array of tУченик): array of real;
begin
  var n := Класс.Length;
  Result := ArrFill(9, 0.0);
  for var Ученик := 0 to n - 1 do
    for var j := 0 to 8 do
      Result[j] += Класс[Ученик].Оценка[j];
  Result.Transform(t -> t / n);
end;

function СреднийБалл(const Класс: array of tУченик):=
    Класс.SelectMany(t->t.Оценка).Average;

procedure ВыводСреднегоБаллаДетально(Баллы: array of real);
begin
  Println('Средние баллы');
  var aПредмет := 'Информатика Математика Физика'.ToWords;
  var aПериод := 'Полугодие1 Полугодие2 Год'.ToWords;
  for var Предмет := 0 to 2 do
    for var Период := 0 to 2 do
      $'{aПредмет[Предмет]} за {aПериод[Период]}: {Баллы[3 * Предмет + Период]}'
         .Println
end;

begin
  var n := ReadlnInteger('Число учеников:');
  var НашКласс := new tУченик[n];
  for var Ученик := 0 to n - 1 do
    Ввод(НашКласс[Ученик]);
  ВыводСреднегоБаллаДетально(СреднийБаллДетально(НашКласс));
  $'Средний балл по классу за год {СреднийБалл(НашКласс):f2}'.Println;  
end.