﻿// p10009
type
  Дети = record
    ФИО: string;
    Пол: char // М/Ж
  end;
  Родители = record
    ФИО: string;
    Дети: LinkedList<Дети>
  end;

function СписокДетей(МассивДетей: array of (string, char)): LinkedList<Дети>;
begin
  Result := new LinkedList<Дети>;
  var Ребенок: Дети;
  (Ребенок.ФИО, Ребенок.Пол) := (МассивДетей[0][0], МассивДетей[0][1]);
  var Узел := Result.AddFirst(Ребенок);
  for var i := 1 to МассивДетей.High do
  begin
    (Ребенок.ФИО, Ребенок.Пол) := (МассивДетей[i][0], МассивДетей[i][1]);
    Узел := Result.AddAfter(Узел, Ребенок)
  end;
end;

procedure Вывод(Родитель: Родители);
begin
  Write(Родитель.ФИО, ': ');
  foreach var Ребенок in Родитель.Дети do
    Write(Ребенок.ФИО, '(', Ребенок.Пол, ') ');
  Writeln;
end;

begin
  var Сотрудники := new LinkedList<Родители>;
  var Сотрудник: Родители;
  
  Сотрудник.ФИО := 'Иванова И.В.';
  Сотрудник.Дети := 
      СписокДетей(Arr(('Иванова Е.К.', 'Ж'), ('Иванов М.К.', 'М')));
  var УзелСотрудники := Сотрудники.AddFirst(Сотрудник);
  
  Сотрудник.ФИО := 'Петров С.Н.';
  Сотрудник.Дети := 
      СписокДетей(Arr(('Петров К.C.', 'М')));
  УзелСотрудники := Сотрудники.AddAfter(УзелСотрудники, Сотрудник);
  
  Сотрудник.ФИО := 'Николаева С.Е.';
  Сотрудник.Дети := 
      СписокДетей(Arr(('Николаев П.С.', 'М'), ('Казьмина Т.И.', 'Ж')));
  УзелСотрудники := Сотрудники.AddAfter(УзелСотрудники, Сотрудник);
  
  Сотрудник.ФИО := 'Курочкина В.Т.';
  Сотрудник.Дети := 
      СписокДетей(Arr(('Курочкина Е.П.', 'Ж')));
  УзелСотрудники := Сотрудники.AddAfter(УзелСотрудники, Сотрудник);
  
  foreach var Работник in Сотрудники do
    Вывод(Работник);
  
end.