﻿// p10010
type
  tDeque = LinkedList<integer>;

var
  Deque: tDeque;

procedure PushHead(data: integer);
begin
  Deque.AddFirst(data);
end;

procedure PushTail(data: integer);
begin
  Deque.AddLast(data);
end;

function NotEmpty := Deque.Count > 0;

function PopHead: integer;
begin
  Assert(NotEmpty, 'Дек пуст');
  Result := Deque.First.Value;
  Deque.RemoveFirst
end;

function PopTail: integer;
begin
  Assert(NotEmpty, 'Дек пуст');
  Result := Deque.Last.Value;
  Deque.RemoveLast
end;

function PeekHead: integer;
begin
  Assert(NotEmpty, 'Дек пуст');
  Result := Deque.First.Value
end;

function PeekTail: integer;
begin
  Assert(NotEmpty, 'Дек пуст');
  Result := Deque.Last.Value
end;

begin
  Deque := new LinkedList<integer>;
  PushTail(1); // 1
  PushTail(2); // 1 2
  PushTail(3); // 1 2 3
  PushHead(4); // 4 1 2 3
  PushTail(5); // 4 1 2 3 5
  Writeln(PeekTail); // вывод 5
  Writeln(Deque); // вывод [4 1 2 3 5] 
  Writeln(PopHead); // вывод 4, в деке 1 2 3 5
  Writeln(PopTail); // вывод 5, в деке 1 2 3
  Writeln(PopHead); // вывод 1, в деке 2 3
  Writeln(PopTail); // вывод 3, в деке 2
  Writeln(PopTail); // вывод 2, дек пуст
  Writeln(PopHead); // ошибка "Дек пуст"
end.