﻿// p13016
type
  Прямоугольник = auto class
    Длина: real;
    Ширина: real;
    function Площадь: real; virtual := Длина * Ширина;
    procedure Вывести; virtual :=
        $'{Длина} x {Ширина} = {Площадь}'.Println;
  end;
  
  Квадрат = class(Прямоугольник)
    Сторона: real;
    constructor(Сторона: real);
    begin
      Self.Сторона := Сторона;
    end;
    function Площадь: real; override := Sqr(Сторона);
    procedure Вывести; override :=
        $'{Сторона} x {Сторона} = {Площадь}'.Println;    
  end;

begin
  var L := new List<Прямоугольник>;
  L.Add(new Прямоугольник(12, 15.5));
  L.Add(new Прямоугольник(18.2, 9.4));
  L.Add(new Квадрат(15));
  foreach var p in L do
    p.Вывести
end.