﻿// p13038
type
  ТреугольникНевозможен = class(Exception)
    constructor;
    begin
      Println('Невозможно построить треугольник');
      Println
    end;
  end;
  
  Треугольник = class
  private 
    aa, bb, cc, r1, r2, P, S, p2: real;
    aa1, bb1, cc1: real;
    
    procedure Вычислить;
    begin
      try
        if (aa + bb > cc) and (aa + cc > bb) and (bb + cc > aa) then
        begin
          P := aa + bb + cc;
          p2 := P / 2;
          S := Sqrt(p2 * (p2 - aa) * (p2 - bb) * (p2 - cc));
          r1 := S / p2;
          r2 := aa * bb * cc / (4 * S);
          ВывестиРезультаты
        end
        else
        begin  
          (aa, bb, cc) := (aa1, bb1, cc1);
          raise new ТреугольникНевозможен
        end
      except
        // сбрасываем возбужденное исключение
      end
    end;
    
    procedure SetAA(v: real);
    begin
      aa1 := aa;
      aa := v;
      Println('Длины сторон:', aa, bb, cc);
      Вычислить
    end;
      
    procedure SetBB(v: real);
    begin
      bb1 := bb;
      bb := v;
      Println('Длины сторон:', aa, bb, cc);
      Вычислить
    end;
    
    procedure SetCC(v: real);
    begin
      cc1 := cc;
      cc := v;
      Println('Длины сторон:', aa, bb, cc);
      Вычислить
    end;
    
    procedure ВывестиРезультаты;
    begin
      $'Периметр {P}, площадь {S:f3}'.Println;
      Writeln('Радиус вписанной окружности ', r1:0:3);
      Writeln('Радиус описанной окружности ', r2:0:3);
      Println
    end;
      
  public 
    
    constructor(pa: real := 3.0; pb: real := 4.0; pc: real := 5.0);
    begin
      (aa, bb, cc) := (pa, pb, pc);
      (aa1, bb1, cc1) := (aa, bb, cc);
      Println('Длины сторон:', aa, bb, cc);
      Вычислить
    end;
    
    property a: real read aa write SetAA;
    property b: real read bb write SetBB;
    property c: real read cc write SetCC;
  
  end;

begin
  var oT := new Треугольник;
  oT.c := 5.1;
  oT.b := 6.7;
  oT.a := 18;
  oT.a := 4.13;
end.