﻿function ЧислоПростое(Число: integer): boolean;
// является ли натуральное число простым?
begin
  if Число < 2 then
    Result := False
  else
    if Число < 4 then
      Result := True
    else
    begin
      var НеДелится := Число.IsOdd;
      var Делитель := 3;
      while НеДелится and (Sqr(Делитель) <= Число) do
      begin
        НеДелится := Число mod Делитель <> 0;
        Делитель += 2
      end;
      Result := НеДелится
    end
end;

begin
  var Множество := SeqRandom(15, 1, 100000).ToHashSet;
  Множество.Println;
  var ПодмножествоПростых := new HashSet<integer>;
  var ПодмножествоСоставных := new HashSet<integer>;
  foreach var Элемент in Множество do
    if ЧислоПростое(Элемент) then
      ПодмножествоПростых += Элемент
    else
      ПодмножествоСоставных += Элемент;
  Print('Простые:');
  ПодмножествоПростых.Println;
  Print('Составные:');
  ПодмножествоСоставных.Println
end.