﻿type
  ВычислитьПОЛИЗ = class
  private
    Слова: array of string;
    Стек: Stack<integer>;
  public
    constructor(ПОЛИЗ: string);
    begin
      Слова := ПОЛИЗ.ToWords;
      Стек := new Stack<integer>;
    end;
    
    function Вычислить: integer;
    begin
      foreach var Слово in Слова do
      begin
        var Целое: integer;
        if Слово.TryToInteger(Целое) then
          Стек.Push(Целое)
        else
          case Слово[1] of
            '+': Стек.Push(Стек.Pop + Стек.Pop);
            '-':
              begin
                var Вычитаемое := Стек.Pop;
                Стек.Push(Стек.Pop - Вычитаемое)
              end;
            '*': Стек.Push(Стек.Pop * Стек.Pop);
            '/':
              begin
                var Делитель := Стек.Pop;
                Стек.Push(Стек.Pop div Делитель)
              end             
          end
      end;
      Result := Стек.Pop
    end;
  end;

begin
  var Объект := new ВычислитьПОЛИЗ('36 18 3 * - 5 4 7 5 - * - /');
  Объект.Вычислить.Println
end.