﻿function Длина(ax, ay, bx, by: real) := 
    Sqrt((bx - ax) ** 2 + (by - ay) ** 2);

function Площадь(ax, ay, bx, by, cx, cy: real): real;
begin
  var la := Длина(bx, by, cx, cy);
  var lb := Длина(ax, ay, cx, cy);
  var lc := Длина(ax, ay, bx, by);
  if (la + lb > lc) and (la + lc > lb) and (lb + lc > la) then
  begin
    var p2 := (la + lb + lc) / 2;
    Result := Sqrt(p2 * (p2 - la) * (p2 - lb) * (p2 - lc))
  end
  else
    Result := 0;
end;

begin
  var ax, ay, bx, by, cx, cy: real;
  Print('Введите координаты x y для каждой точки:');
  Read(ax, ay, bx, by, cx, cy);
  var S := Площадь(ax, ay, bx, by, cx, cy);
  if S = 0 then
    Println('Треугольник невозможен')
  else
    Writeln('S = ', S:0:2)
end.