﻿function ТреугольникВозможен(p: string): boolean;
begin
  var m := p.ToWords;
  var a := m[0].ToInteger;
  var b := m[1].ToInteger;
  var c := m[2].ToInteger;
  Result := (a + b > c) and (a + c > b) and (b + c > a)
end;

function Площадь(p: string): real;
begin
  var m := p.ToWords;
  var a := m[0].ToInteger;
  var b := m[1].ToInteger;
  var c := m[2].ToInteger;
  var pp := (a + b + c) / 2;
  Result := Sqrt(pp * (pp - a) * (pp - b) * (pp - c))
end;

begin
  var n := 500000;
  var fn := 'MyFile.txt';
  var f := OpenWrite(fn);
  loop n do
  begin
    var r := Random3(1, 99);
    Writeln(f, r[0], ' ', r[1], ' ', r[2])
  end;
  f.Close;
  f := OpenWrite('Temp.tmp');
  foreach var s in ReadAllLines(fn) do
    if ТреугольникВозможен(s) then
      f.Writeln(s);
  f.Close;
  DeleteFile(fn);
  Rename(f, fn);
  var s := ReadAllLines(fn).Select(t -> Площадь(t)).Average;
  $'Средняя площадь равна {s:f3}'.Println
end.