﻿type
  Треугольник = class
  
  private 
    aa, bb, cc, r1, r2, P, S, p2: real;
    
    procedure Вычислить;
    begin
      P := aa + bb + cc;
      p2 := P / 2;
      S := Sqrt(p2 * (p2 - aa) * (p2 - bb) * (p2 - cc));
      r1 := S / p2;
      r2 := aa * bb * cc / (4 * S)
    end;
    
    procedure Обнулить;
    begin
      (P, p2, S, r1, r2) := (0, 0, 0, 0, 0)
    end;
    
    procedure SetAA(v: real);
    begin
      aa := v;
      ВывестиРезультаты;
      if not ВозможенТреугольник then Обнулить
    end;
    
    procedure SetBB(v: real);
    begin
      bb := v;
      ВывестиРезультаты;
      if not ВозможенТреугольник then Обнулить
    end;
    
    procedure SetCC(v: real);
    begin
      cc := v;
      ВывестиРезультаты;
      if not ВозможенТреугольник then Обнулить
    end;
    
    function ВозможенТреугольник :=
    (aa + bb > cc) and (aa + cc > bb) and (bb + cc > aa);
    
    procedure ВывестиРезультаты;
    begin
      Println('Длины сторон:', aa, bb, cc);
      if ВозможенТреугольник then
      begin
        Вычислить;
        $'Периметр {P}, площадь {S:f3}'.Println;
        Writeln('Радиус вписанной окружности ', r1:0:3);
        Writeln('Радиус описанной окружности ', r2:0:3)
      end
      else Println('Треугольник не существует')
    end;
      
  public 
    
    constructor(pa: real := 3.0; pb: real := 4.0; pc: real := 5.0);
    begin
      aa := pa;
      bb := pb;
      cc := pc;;
      ВывестиРезультаты;
      if not ВозможенТреугольник then Обнулить
    end;
    
    property a: real read aa write SetAA;
    property b: real read bb write SetBB;
    property c: real read cc write SetCC;
  
  end;

begin
  var oT := new Треугольник;
  oT.c := 5.1;
  oT.b := 6.7;
  oT.a := 18;
end.