﻿// p13022
type
  Люди = auto class
    Имя: string;
  end;
  
  Сотрудники = class(Люди)
    Компания: string;
    constructor(Имя, Компания: string) :=
        (Self.Имя, Self.Компания) := (Имя, Компания);
    procedure Deconstruct(var Имя, Компания: string);
    begin
      Имя := Self.Имя;
      Компания := Self.Компания
    end;
  end;
  
  Клиенты = class(Люди)
    Банк: string;
    constructor(Банк, Имя: string) :=
        (Self.Банк, Self.Имя) := (Банк, Имя);
    procedure Deconstruct(var Имя, Банк: string);
    begin
      Имя := Self.Имя;
      Банк := Self.Банк
    end;
  end;
 
begin
  var Человек: Люди := new Сотрудники('Шура','Рога и копыта');
  if Человек is Сотрудники(var Имя, var Компания) then
  begin  
    Println($'Человек: {Человек.Имя}');
    Println($'Сотрудник: {Имя}, "{Компания}"')
  end
end.